<?php

require_once "abstract.ilPluginTableDatabaseDataProvider.php";

/**
 * Class ilQuestionSetPoolNodeProvider
 *
 * Date: 21.11.13
 * Time: 12:23
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilQuestionSetPoolNodeProvider extends ilPluginTableDatabaseDataProvider
{

	/**
	 * @return string
	 */
	protected function getSelectPart()
	{
		$select = array(
			"rep_robj_xqsp_node.*",
			"rep_robj_xqsp_qs.id as set_fi",
			"qpl_questions.title as question_title",
			"rep_robj_xqsp_qs_qst.question_index",
	//		"rep_robj_xqsp_jmp_con.*"
		);

		return join(", ", $select);
	}

	/**
	 * @return string
	 */
	protected function getFromPart()
	{
		return "rep_robj_xqsp_node";
	}

	/**
	 * @return string
	 */
	protected function getJoinPart()
	{
		$join = array(
			"INNER JOIN qpl_questions ON qpl_questions.question_id = rep_robj_xqsp_node.question_fi",
			"INNER JOIN rep_robj_xqsp_path ON rep_robj_xqsp_path.id = rep_robj_xqsp_node.path_fi",
			"INNER JOIN rep_robj_xqsp_qs ON rep_robj_xqsp_qs.id = rep_robj_xqsp_path.questionset_fi",
			"INNER JOIN rep_robj_xqsp_qs_qst ON rep_robj_xqsp_qs_qst.question_fi = qpl_questions.question_id",
	//		"INNER JOIN rep_robj_xqsp_jmp_con ON rep_robj_xqsp_jmp_con.node_fi = rep_robj_xqsp_node.id"
		);
		return implode(" ", $join);
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getWherePart(array $filter)
	{
		return "rep_robj_xqsp_node.path_fi =" . $this->db->quote($filter['path_fi']);
	}

	/**
	 * @return string
	 */
	protected function getGroupByPart()
	{
		return "";
	}

	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getHavingPart(array $filter)
	{
		return "";
	}

	/**
	 * @param array $params
	 *
	 * @return string
	 */
	protected function getOrderByPart(array $params)
	{
		return "rep_robj_xqsp_node.node_index ASC";
	}
}
 