<?php

require_once "abstract.ilPluginTableDatabaseDataProvider.php";

/**
 * Class ilObjQuestionSetPoolQuestionBrowserProvider
 *
 * Date: 16.04.13
 * Time: 16:12
 * @author Thomas Joußen <tjoussen@databay.de>
 */ 
class ilQuestionSetPoolQuestionsBrowserProvider extends ilPluginTableDatabaseDataProvider
{

	/**
	 * @return string
	 */
	protected function getSelectPart()
	{
		$fields = array(
			"qpl_questions.*",
			"qpl_qst_type.type_tag",
			"qpl_qst_type.plugin",
			"object_data.title pool_title",
			"object_reference.ref_id pool_ref_id"
		);

		return implode(", ", $fields);
	}

	/**
	 * @return string
	 */
	protected function getFromPart()
	{
		$from = array(
			"qpl_questions",

		);

		return implode(", ", $from);
	}

	/**
	 * @return string
	 */
	protected function getJoinPart()
	{
		$joins = array(
			"INNER JOIN qpl_qst_type ON qpl_questions.question_type_fi = qpl_qst_type.question_type_id",
			"INNER JOIN object_data ON object_data.obj_id = qpl_questions.obj_fi",
			"INNER JOIN object_reference ON object_reference.obj_id = qpl_questions.obj_fi",
			//"LEFT JOIN rep_robj_xqsp_question ON qpl_questions.question_id = rep_robj_xqsp_question.question_fi"
		);

		return implode(" ", $joins);
	}


	/**
	 * @param array $filter
	 *
	 * @return string
	 */
	protected function getWherePart(array $filter)
	{
		$excludes = array(
			14,
			8
		);
		$types = array_merge($excludes, ilObjAssessmentFolder::_getManualScoring());

		$where = array(
			"qpl_questions.original_id IS NULL",
			"qpl_questions.tstamp > 0",
//			"(rep_robj_xqsp_question.questionsetpool_fi IS NULL OR rep_robj_xqsp_question.questionsetpool_fi != " . $this->db->quote($filter['xqsp_id'], 'integer') . ")",
//			"rep_robj_xqsp_question.questionsetpool_fi != " . $this->db->quote($filter['xqsp_id'], 'integer'),
			$this->db->in("qpl_qst_type.question_type_id", $types, true, "integer"),
			$this->db->in('qpl_questions.obj_fi', $filter["question_pools"], false, 'integer'),
			"qpl_questions.complete = " . $this->db->quote("1", "text")
		);

		$where = $this->addOptionalFilterElements($filter, $where);

		return implode(" AND ", $where);
	}

	/**
	 * @return string
	 */
	protected function getGroupByPart()
	{
		return "";
	}

	/**
	 * @param array $filter
	 * @return string
	 */
	protected function getHavingPart(array $filter)
	{
		return "";
	}

	/**
	 * @param array $params
	 * @return string
	 */
	protected function getOrderByPart(array $params)
	{
		return "";
	}

	/**
	 * @param array $filter
	 * @param       $where
	 *
	 * @return array
	 */
	protected function addOptionalFilterElements(array $filter, $where)
	{
		if ($filter["question_type"])
		{
			$where[] = "qpl_qst_type.type_tag = " . $this->db->quote($filter["question_type"], "text");
		}
		if ($filter["title"])
		{
			$where[] = $this->db->like("qpl_questions.title", "text", "%".$filter["title"]."%");
		}
		if ($filter["description"])
		{
			$where[] = $this->db->like("qpl_questions.description", "text", "%".$filter["description"]."%");
		}
		if ($filter["author"])
		{
			$where[] = $this->db->like("qpl_questions.author", "text", "%".$filter["author"]."%");
		}
		if ($filter["qpl"])
		{
			$where[] = $this->db->like("object_data.title", "text", "%".$filter["qpl"]."%");
		}

		return $where;
	}
}
